;--------------------------------------------------------------------------------
;	PIC16F687E3F\dv Programmed by GRANADA
;	Ver 1.0		2010/07/07 ` PIC16F687 3Fxxv
;	Ver 1.2		2010/07/09 ` F\t]ΉAϒl\ΉAf[^ݎ擾Ή
;	Ver 1.3		2010/07/13 ` ϒlvZdɌ肵ă`y
;	Ver 1.4		2010/07/14 ` f[^ωƂ̂ݍČvZłɃ`y
;	i{\[XvO̓^u4ɐݒ肷Yɐ`܂j
;	LF http://www.asahi-net.or.jp/~SE1M-NITU/html/3color_Voltage_Meter.htm
;--------------------------------------------------------------------------------

	LIST		P=16F687
	INCLUDE		P16F687.INC

	ERRORLEVEL	-205
	ERRORLEVEL	-302

	__CONFIG _FCMEN_OFF & _CP_OFF & _CPD_OFF & _BOR_ON & _PWRTE_ON & _MCLRE_OFF & _INTRC_OSC_NOCLKOUT & _IESO_OFF & _WDT_OFF

;--------------------------------------------------------------------------------
;	ϐAhX`
;--------------------------------------------------------------------------------

CBLOCK	H'20'			; [U[pt@CWX^iϐ̈j擪AhX

	AD_H				; A/D ϊlʈꎞXgAp
	AD_L				; A/D ϊlʈꎞXgAp

	VLT_H				; dlXgAp
	VLT_L

	MAX_H				; F\lXgAp
	MAX_L

	MIN_H				; F\lXgAp
	MIN_L

	VOLTAGE				; \p[NAdli10iǒl x 10j
	MIN					; \p[NAF\̉li10iǒl x 10j
	MAX					; \p[NAF\̏li10iǒl x 10j

	BCD_H				; BCD ϊl
	BCD_M				; BCD ϊl
	BCD_L				; BCD ϊl

	PATTERN_H			; ʃrbgp^[E}X^[p^[
	PATTERN_M			; ʃrbgp^[E}X^[p^[
	PATTERN_L			; ʃrbgp^[E}X^[p^[

	SEGMENT				; \rbgp^[

	USER_FLAG			; etO
	COLOR_FLAG			; xF̐ptO, bit = 1  _

	TMP					; Gp[N

ENDC

CBLOCK	H'50'

	A1_tmp				; ݏ̑ޔp
	A2_tmp
	B1_tmp
	B2_tmp
	Ctemp_tmp

	V_TOTAL_H			; d̗ݐϒl
	V_TOTAL_L

	VTH					; ϒlvZp[N
	VTL

	VLT_H_CURR			; O̓dl
	VLT_L_CURR

	MAX_H_CURR			; O̞F\l
	MAX_L_CURR

	MIN_H_CURR			; O̞F\l
	MIN_L_CURR

ENDC

CBLOCK	H'70'			; SoNʃt@CWX^擪AhX

	W_WORK				; 荞ݎ W WX^ޔp
	ST_WORK				; 荞ݎ̃Xe[^XWX^ޔp

	INT_COUNTER			; ݉񐔌vpJE^[

	COUNTER1			; ԑ҂p
	COUNTER2			; ԑ҂p
	COUNTER3			; ԑ҂p

ENDC

;--------------------------------------------------------------------------------
;	萔`, DEFINE g MPLAB SIM ̃t@CWX^_vɕ֗
;	it@CWX^ɒ萔ꍞ܂Ȃj
;--------------------------------------------------------------------------------

#DEFINE		FACTOR		D'5'	; A/Dϊl  10iǒlx10ւ̕ϊt@N^[
								; drd 1/4 ē͂ 20V = 1000JEgB
								;  5 ŊΒǒl x 10 (=200) 
#DEFINE		AVG			D'15'	; dsĕϒlZo邩i=݉񐔁j

#DEFINE		MAX_IN		0		; F\l̓|[gԍ
#DEFINE		MIN_IN		1		; F\l̓|[gԍ
#DEFINE		V_IN		2		; d̓|[gԍ
#DEFINE		MODE		3		; [hݒ|[gԍ

#DEFINE		G1			0		; PORTC
#DEFINE		G2			1		; PORTC
#DEFINE		G3			2		; PORTC
#DEFINE		R1			4		; PORTB
#DEFINE		R2			5		; PORTB
#DEFINE		R3			6		; PORTB

;--------------------------------------------------------------------------------
;	|[g`
;--------------------------------------------------------------------------------
;RA0			ANALOG  IN		l
;RA1			ANALOG	IN		l
;RA2	d		ANALOG  IN		d
;RA3	[h		DIGITAL	IN		H = ԁ򁨗΁ԁiԍڃ[hjAL=΁򁨐

;RB4	R1			DIGITAL	OUT
;RB5	R2			DIGITAL OUT
;RB6	R3			DIGITAL OUT

;RC0	G1			DIGITAL	OUT
;RC1	G2			DIGITAL OUT
;RC2	G3			DIGITAL OUT

;RB7	LED a		DIGITAL OUT
;RC7	LED b		DIGITAL OUT
;RC6	LED c		DIGITAL OUT
;RC3	LED d		DIGITAL OUT
;RC4	LED e		DIGITAL OUT
;RC5	LED f		DIGITAL OUT
;RA4	LED g		DIGITAL OUT
;RA5	LED dp		DIGITAL OUT

#DEFINE		GREEN_BIT	COLOR_FLAG,0	; FtÕrbgԍ
#DEFINE		RED_BIT		COLOR_FLAG,1	; FtÕrbgԍ

#DEFINE		MEAS_OK		USER_FLAG,0		; 1 = f[^擾

#DEFINE		MODE_PORT	PORTA,MODE		; \[h̃|[g`

#DEFINE		R1_PORT	PORTB,R1
#DEFINE		R2_PORT	PORTB,R2
#DEFINE		R3_PORT	PORTB,R3

#DEFINE		G1_PORT	PORTC,G1
#DEFINE		G2_PORT	PORTC,G2
#DEFINE		G3_PORT	PORTC,G3

#DEFINE		A_SEG	PORTB,7			; LED  a ZOg̃|[gԍ
#DEFINE		B_SEG	PORTC,7			; LED  b ZOg̃|[gԍ
#DEFINE		C_SEG	PORTC,6			; LED  c ZOg̃|[gԍ
#DEFINE		D_SEG	PORTC,3			; LED  d ZOg̃|[gԍ
#DEFINE		E_SEG	PORTC,4			; LED  e ZOg̃|[gԍ
#DEFINE		F_SEG	PORTC,5			; LED  f ZOg̃|[gԍ
#DEFINE		G_SEG	PORTA,4			; LED  g ZOg̃|[gԍ
#DEFINE		DP_SEG	PORTA,5			; LED dp ZOg̃|[gԍ

;--------------------------------------------------------------------------------
;	}N`
;--------------------------------------------------------------------------------

BANK0	macro
		BCF		STATUS,RP1
		NOP
		BCF		STATUS,RP0
		endm

BANK1	macro
		BCF		STATUS,RP1
		NOP
		BSF		STATUS,RP0
		endm

BANK2	macro
		BSF		STATUS,RP1
		NOP
		BCF		STATUS,RP0
		endm

BANK3	macro
		BSF		STATUS,RP1
		NOP
		BSF		STATUS,RP0
		endm

;--------------------------------------------------------------------------------
;	vO擪
;--------------------------------------------------------------------------------

	ORG		H'0'
	GOTO	INITIALIZE

;--------------------------------------------------------------------------------
;	荞ݏ (32ms)
;--------------------------------------------------------------------------------

	ORG		H'4'			; 荞ݏ擪AhX

	MOVWF	W_WORK			; WX^Ҕ
	SWAPF	STATUS,W		; Z tOeȂ悤AMOVF ł͂Ȃ SWAPF gp
	MOVWF	ST_WORK			; STATUS WX^ۑ Bank A\

	MOVF	A1,W
	MOVWF	A1_tmp			; ݏ̑ޔp
	MOVF	A2,W
	MOVWF	A2_tmp			; ݏ̑ޔp
	MOVF	B1,W
	MOVWF	B1_tmp			; ݏ̑ޔp
	MOVF	B2,W
	MOVWF	B2_tmp			; ݏ̑ޔp
	MOVF	Ctemp,W
	MOVWF	Ctemp_tmp		; ݏ̑ޔp
;
;	ݏ{
;
	CALL	GET_DATA		; d`lݐ (32ms)

	DECFSZ	INT_COUNTER,F	; JE^`FbN
	GOTO	POP_REG			; 񐔖̏ꍇ͉ȂŖ߂
;
;	f[^擾
;
	MOVF	V_TOTAL_H,W		; vlCɓnߑޔ
	MOVWF	VTH
	MOVF	V_TOTAL_L,W
	MOVWF	VTL

	CALL	CLEAR_PARAM		; ݊֌W & ϒlp[^Qď

	BSF		MEAS_OK			; f[^擾tO𗧂Ă

POP_REG:					; WX^A`荞ݏI

	MOVF	B2_tmp,W
	MOVWF	B2
	MOVF	B1_tmp,W
	MOVWF	B1
	MOVF	A2_tmp,W
	MOVWF	A2
	MOVF	A1_tmp,W
	MOVWF	A1
	MOVF	Ctemp_tmp,W	
	MOVWF	Ctemp

	SWAPF	ST_WORK,W
	MOVWF	STATUS
	SWAPF	W_WORK,F
	SWAPF	W_WORK,W

	BCF		INTCON,T0IF		; TMR0荞݃tONAĂ
	RETFIE					; 荞ݏI

;--------------------------------------------------------------------------------
;	1̐7ZOgrbgp^[Ԃ
;--------------------------------------------------------------------------------

GET_7SEG_PATTERN:

	ADDWF	PCL,F
;              gfedcba
	RETLW	B'00111111'	;	0
	RETLW	B'00000110'	;	1
	RETLW	B'01011011'	;	2
	RETLW	B'01001111'	;	3
	RETLW	B'01100110'	;	4
	RETLW	B'01101101'	;	5
	RETLW	B'01111101'	;	6
	RETLW	B'00100111'	;	7
	RETLW	B'01111111'	;	8
	RETLW	B'01101111'	;	9

;--------------------------------------------------------------------------------
; Lϊe[u̓AZuAhX100ԒnɎ߂邱ƁI
;--------------------------------------------------------------------------------

;--------------------------------------------------------------------------------
;	vOX^[g
;--------------------------------------------------------------------------------

INITIALIZE:

	BANKSEL	PORTA
	CLRF	PORTA			; ALL LED OFF
	CLRF	PORTB
	CLRF	PORTC

	BANKSEL	OSCCON			; Bank 1
	MOVLW	B'01110100'		; NbN 8MHz ɐݒibit 3 ݒ肪 16F88 ƈقȂ_ɒӁj
	MOVWF	OSCCON

	CLRF	PIE1			; Bank 1, 荞݂͂ЂƂ܂Sĕs

	CLRF	TRISA			; Bank 1, ЂƂ܂S|[go͂Ɏw
	CLRF	TRISB			; Bank 1
	CLRF	TRISC			; Bank 1

	BSF		TRISA,MAX_IN	; ͍Đݒ
	NOP
	BSF		TRISA,MIN_IN	; ͍Đݒ
	NOP
	BSF		TRISA,V_IN		; ͍Đݒ

	BANK2					; macro

	CLRF	ANSEL			; Bank 2, ЂƂ܂S|[gfW^ɐݒ
	CLRF	ANSELH			; Bank 2
	BSF		ANSEL,V_IN		; d̓|[gAiOɐݒ
	NOP
	BSF		ANSEL,MAX_IN	; lݒ|[gAiOɐݒ
	NOP
	BSF		ANSEL,MIN_IN	; lݒ|[gAiOɐݒ

;--------------------------------------------------------------------------------
;	A/D Ro[^[ݒ (10bit)
;--------------------------------------------------------------------------------

	BANKSEL	ADCON1
	MOVLW	B'00100000'		; Bank 1, 32 Tosc ibit ̋@\ 16F88 ƈقȂj
	MOVWF	ADCON1

	BANKSEL ADCON0			; Bank 0
	MOVLW	B'10001001'		; El(10bit A/Dϊ), Vref=VDD, AN2 (bit 5-2) gp, AD Ro[^d ON
	MOVWF	ADCON0

	CALL	WAIT_10us		; Ô߃v`[WĂ

;--------------------------------------------------------------------------------
;	TMR0 ݒ, 32ms 荞ݔݒ
;--------------------------------------------------------------------------------

	BANKSEL	OPTION_REG		; Bank 1
	MOVLW	B'10000111'		; PORTA,B pull up disable, TMR0 interanal clock, PSA = TMR0, PS = 1:256
	MOVWF	OPTION_REG

	BANKSEL	PORTA			; Bank 0

	CALL	CLEAR_PARAM		; dݐϒl & ݊֌Wϐ

	CLRF	USER_FLAG		; etO
	CLRF	COLOR_FLAG		; \FtO

	CALL	SET_RED
	CALL	SET_GREEN		; F\

	CLRF	PATTERN_H		; uN\ŃX^[g
	CLRF	PATTERN_M		; i݂Ńf[^擾܂ł͂̃p^[\j
	BSF		PATTERN_M,7		; _\
	CLRF	PATTERN_L

	CLRF	TMR0			; ^C}[

	BSF		INTCON,T0IE		; TMR0I[o[t[荞ݔ
	BSF		INTCON,GIE		; 荞݋

;--------------------------------------------------------------------------------
;	C[vJn
;--------------------------------------------------------------------------------

MAIN_LOOP:

	BTFSS	MEAS_OK			; f[^擾 ?
	GOTO	MAIN2			; ܂lݐϒȂ̂ŕ\f[^͍XVȂ

	CALL	GET_DATA2		; lAl

	BCF		MEAS_OK			; f[^擾tOZbg

	CALL	CALC_AVERAGE	; X^bN̂ߕϒlvZ̓Cōs

							; dAlAlɕω̂݃f[^ČvZ邱ƂŃ`ɗ͒ጸ

	MOVF	VLT_L_CURR,W	; dlωo
	SUBWF	VLT_L,W
	BTFSS	STATUS,Z
	GOTO	UPDATE			; ʂvȂ̂ōČvZ

	MOVF	VLT_H_CURR,W
	SUBWF	VLT_H,W
	BTFSS	STATUS,Z
	GOTO	UPDATE			; ʂvȂ̂ōČvZ

	MOVF	MAX_L_CURR,W	; lωo
	SUBWF	MAX_L,W
	BTFSS	STATUS,Z
	GOTO	UPDATE			; ʂvȂ̂ōČvZ

	MOVF	MAX_H_CURR,W
	SUBWF	MAX_H,W
	BTFSS	STATUS,Z
	GOTO	UPDATE			; ʂvȂ̂ōČvZ

	MOVF	MIN_L_CURR,W	; lωo
	SUBWF	MIN_L,W
	BTFSS	STATUS,Z
	GOTO	UPDATE			; ʂvȂ̂ōČvZ

	MOVF	MIN_H_CURR,W
	SUBWF	MIN_H,W
	BTFSC	STATUS,Z
	GOTO	MAIN2			; SĈv̂Ńf[^͂̂܂

UPDATE:						; X^bN̂߁A\f[^XV̓Cōs

	CALL	CONV_DATA		; A/D ϊl𒼓ǒlx10֕ϊ
	CALL	SET_PARAMETERS	; \̊e퉺

	MOVF	VLT_H,W			; ωopɌ݂̃f[^ۑĂ
	MOVWF	VLT_H_CURR
	MOVF	VLT_L,W
	MOVWF	VLT_L_CURR

	MOVF	MAX_H,W
	MOVWF	MAX_H_CURR
	MOVF	MAX_L,W
	MOVWF	MAX_L_CURR

	MOVF	MIN_H,W
	MOVWF	MIN_H_CURR
	MOVF	MIN_L,W
	MOVWF	MIN_L_CURR

MAIN2:

	CALL	DISPLAY			; LED _Ci~bN_

	GOTO	MAIN_LOOP

;--------------------------------------------------------------------------------
;	ȉTu[`Q
;--------------------------------------------------------------------------------

;--------------------------------------------------------------------------------
;	LED \ZOgp^[A\F̌
;
;	IN		VOLTAGE			ϓdi10iǒlx10j
;			MIN				ϞF\li10iǒlx10j
;			MAX				ϞF\li10iǒlx10j
;
;	RETURN	COLOR_FLAG		J[tOirbgj
;			PATTERN_H		ʂ̃ZOgp^[
;			PATTERN_M		ʂ̃ZOgp^[
;			PATTERN_L		ʂ̃ZOgp^[
;--------------------------------------------------------------------------------

SET_PARAMETERS:

	CLRF	COLOR_FLAG		; Frbg
	CLRF	PATTERN_H		; \p^[
	CLRF	PATTERN_M		; \p^[
	CLRF	PATTERN_L		; \p^[

	CLRF	prm1b			; ʃNA
	MOVF	VOLTAGE,W		; VOLTAGE = 10iǒlx10 Ȃ̂ŉ8bitm
	MOVWF	prm1a			; ʃZbg

	CALL	HEX2DEC16		; 16bitl -> 5 BCD ϊ
							; X^bNƕϐی̂ߊ荞݂͖ɂĂ

	MOVF	prm3a,W			; BCD
	MOVWF	BCD_L			; XgA
	MOVF	prm3b,W			; BCD 
	MOVWF	BCD_M			; XgA
	MOVF	prm3c,W			; BCD 
	MOVWF	BCD_H			; XgA

;--------------------------------------------------------------------------------
;	\F
;--------------------------------------------------------------------------------

	BTFSS	MODE_PORT		; Jumper open  = H = ԍڃ[hiԁ򁨗΁ԁj
	GOTO	GREEN2RED		; Jumper close = L = ʏ탂[hi΁򁨐ԁj

SET_COLOR:					; ԁ򁨗΁ԕ\[hiԍڃ[hj

							; ŏɌxl𒴂ǂ`FbNĂ܂
	MOVLW	D'150'			; 15.0V x 10
	SUBWF	VOLTAGE,W		; VOLTAGE - 150 -> W
	BTFSC	STATUS,C		; VOLTAGE < 150 Ȃ؂ꔭ C=0  ̖߃XLbv
	GOTO	RED				; xl𒴂

	MOVF	MIN,W
	SUBWF	VOLTAGE,W		; VOLTAGE - MIN(W) -> W
	BTFSS	STATUS,C		; VOLTAGE >= MIN Ȃ؂ꔭ C=1  ̖߃XLbv
	GOTO	RED

	MOVF	MAX,W
	SUBWF	VOLTAGE,W		; VOLTAGE - MAX(W) -> W
	BTFSS	STATUS,C		; VOLTAGE >= MAX Ȃ؂ꔭ C=1  ̖߃XLbv
	GOTO	ORANGE			; F\
	GOTO	GREEN			; MAX ȏȂΕ\

GREEN2RED:					; ΁򁨐ԕ\[hiʏ탂[hj

	MOVF	MIN,W
	SUBWF	VOLTAGE,W		; VOLTAGE - MIN(W) -> W
	BTFSS	STATUS,C		; VOLTAGE >= MIN Ȃ؂ꔭ C=1  ̖߃XLbv
	GOTO	GREEN

	MOVF	MAX,W
	SUBWF	VOLTAGE,W		; VOLTAGE - MAX(W) -> W
	BTFSS	STATUS,C		; VOLTAGE >= MAX Ȃ؂ꔭ C=1  ̖߃XLbv
	GOTO	ORANGE			; F\
							; MAX ȏȂԕ\

;--------------------------------------------------------------------------------
;	\F̃tO
;--------------------------------------------------------------------------------

RED:						; 

	CALL	SET_RED
	GOTO	GET_LED_PATTERN

GREEN:						; 

	CALL	SET_GREEN
	GOTO	GET_LED_PATTERN

ORANGE:						; 

	CALL	SET_RED
	CALL	SET_GREEN
	GOTO	GET_LED_PATTERN

;--------------------------------------------------------------------------------
;	Frbg̃Zbg
;--------------------------------------------------------------------------------

SET_RED:

	BSF		RED_BIT
	RETURN

SET_GREEN:

	BSF		GREEN_BIT
	RETURN

;--------------------------------------------------------------------------------
;	BCD lɊÂ LED \p^[ɃZbg
;--------------------------------------------------------------------------------

GET_LED_PATTERN:

	MOVF	BCD_L,W				; .1̈ʂ𓾂
	CALL	GET_7SEG_PATTERN	; ϊ
	MOVWF	PATTERN_L			; p^[ۑ

	MOVF	BCD_M,W				; 1̈ʂ𓾂
	CALL	GET_7SEG_PATTERN	; ϊ
	MOVWF	PATTERN_M			; p^[ۑ
	BSF		PATTERN_M,7			; 1̈ʂ dp \

	MOVF	BCD_H,W
	BTFSS	STATUS,Z			; ŏʂ0 ?
	GOTO	SET_H_PATTERN		; 0 łȂ̂Œʏ폈

	CLRF	PATTERN_H			; ŏʂ̓uN

	RETURN

SET_H_PATTERN:

	MOVF	BCD_H,W				; 10̈ʂ𓾂
	CALL	GET_7SEG_PATTERN	; ϊ
	MOVWF	PATTERN_H			; p^[ۑ

	RETURN

;--------------------------------------------------------------------------------
;	_Ci~bN_
;	PATTERN_H	ʌZOgp^[
;	PATTERN_M	ʌZOgp^[
;	PATTERN_L	ʌZOgp^[
;--------------------------------------------------------------------------------

DISPLAY:

	CALL	ALL_LED_OFF			; S

;--------------------------------------------------------------------------------
;	LED1 \
;--------------------------------------------------------------------------------

	BTFSC	GREEN_BIT			; ΃rbg 0 Ȃ玟XLbv
	BSF		G1_PORT				; H  ON (H=_)

	BTFSC	RED_BIT				; ԃrbg 0 Ȃ玟XLbv
	BSF		R1_PORT				; H  ON (H=_)

	MOVF	PATTERN_H,W			; ʌp^[ǂݏo
	CALL	SEG_A				; ZOgJn

	CALL	ALL_LED_OFF			; S

;--------------------------------------------------------------------------------
;	LED2 \
;--------------------------------------------------------------------------------

	BTFSC	GREEN_BIT			; ΃rbg 0 Ȃ玟XLbv
	BSF		G2_PORT				; L  ON (H=_)

	BTFSC	RED_BIT				; ԃrbg 0 Ȃ玟XLbv
	BSF		R2_PORT				; L  ON (H=_)

	MOVF	PATTERN_M,W			; ʌp^[ǂݏo
	CALL	SEG_A				; ZOgJn

	CALL	ALL_LED_OFF			; S

;--------------------------------------------------------------------------------
;	LED3 \
;--------------------------------------------------------------------------------

	BTFSC	GREEN_BIT			; ΃rbg 0 Ȃ玟XLbv
	BSF		G3_PORT				; H  ON (H=_)

	BTFSC	RED_BIT				; ԃrbg 0 Ȃ玟XLbv
	BSF		R3_PORT				; H  ON (H=_)

	MOVF	PATTERN_L,W			; ʌp^[ǂݏo
	CALL	SEG_A				; ZOgJn

	CALL	ALL_LED_OFF			; S

	RETURN

;--------------------------------------------------------------------------------
;	ZOg
;	IN: W = rbgp^[
;	    DP_FLAG = 1 -> DP \
;--------------------------------------------------------------------------------

SEG_A:

	MOVWF	SEGMENT				; ZOgp^[ۑĂ

	BTFSS	SEGMENT,0			; a ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_B				; ̃ZOg

	BSF		A_SEG				; a ZOg_
	CALL	HOLD_LED
	BCF		A_SEG				; a ZOg
	CALL	HOLD_LED_SHORT

SEG_B:

	BTFSS	SEGMENT,1			; b ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_C				; ̃ZOg

	BSF		B_SEG				; b ZOg_
	CALL	HOLD_LED
	BCF		B_SEG				; b ZOg
	CALL	HOLD_LED_SHORT

SEG_C:

	BTFSS	SEGMENT,2			; c ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_D				; ̃ZOg

	BSF		C_SEG				; c ZOg_
	CALL	HOLD_LED
	BCF		C_SEG				; c ZOg
	CALL	HOLD_LED_SHORT

SEG_D:

	BTFSS	SEGMENT,3			; d ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_E				; ̃ZOg

	BSF		D_SEG				; d ZOg_
	CALL	HOLD_LED
	BCF		D_SEG				; d ZOg
	CALL	HOLD_LED_SHORT

SEG_E:

	BTFSS	SEGMENT,4			; e ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_F				; ̃ZOg

	BSF		E_SEG				; e ZOg_
	CALL	HOLD_LED
	BCF		E_SEG				; e ZOg
	CALL	HOLD_LED_SHORT

SEG_F:

	BTFSS	SEGMENT,5			; f ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_G				; ̃ZOg

	BSF		F_SEG				; f ZOg_
	CALL	HOLD_LED
	BCF		F_SEG				; f ZOg
	CALL	HOLD_LED_SHORT

SEG_G:

	BTFSS	SEGMENT,6			; g ZOgrbg 1 Ȃ玟̖߂XLbv
	GOTO	SEG_DP				; ̃ZOg

	BSF		G_SEG				; g ZOg_
	CALL	HOLD_LED
	BCF		G_SEG				; g ZOg
	CALL	HOLD_LED_SHORT

SEG_DP:

	BTFSS	SEGMENT,7			; dp ZOgrbg 1 Ȃ玟̖߂XLbv
	RETURN						; dp ZOg_ȂȂ߂

	BSF		DP_SEG				; dp ZOg_
	CALL	HOLD_LED
	BCF		DP_SEG				; dp ZOg
	CALL	HOLD_LED_SHORT

	RETURN

;--------------------------------------------------------------------------------
;	LED \莞ԕێi߁j
;--------------------------------------------------------------------------------

HOLD_LED:

	CALL	WAIT_100us

	RETURN

;--------------------------------------------------------------------------------
;	LED \莞ԕێiZ߁j
;--------------------------------------------------------------------------------

HOLD_LED_SHORT:

	NOP							; 8MHz 0.5us

	RETURN

;--------------------------------------------------------------------------------
;	LED SiSZOgA|[g L Ɂj
;--------------------------------------------------------------------------------

ALL_LED_OFF:

	CLRF	PORTA
	CLRF	PORTB
	CLRF	PORTC

	RETURN

;--------------------------------------------------------------------------------
;	10 bit A/D ϊs
;	RETURN: AD_H, AD_L
;--------------------------------------------------------------------------------

READ_VOLTAGE10:

	BSF		ADCON0,GO		; GO (start) bit 𗧂Ă A/D ϊJn

WAIT_AD:

	BTFSC	ADCON0,GO		; A/D ϊI? 0 Ȃ玟XLbv
	GOTO	WAIT_AD			; ܂ϊ

	MOVF	ADRESH,W		; Bank 0, A/D ϊliʁjǂݏo
	MOVWF	AD_H			; ɃXgA

	BCF		INTCON,T0IE		; oN؂ւ TMR0 荞ݔ֎~

	BANKSEL	ADRESL			; Bank 1
	MOVF	ADRESL,W		; A/D ϊliʁjǂݏo

	BANKSEL	PORTA			; Bank 0
	MOVWF	AD_L			; ɃXgA (BANK0ɂ_ɒӁj

	BSF		INTCON,T0IE		; ݍċ

	RETURN

;--------------------------------------------------------------------------------
;	drd擾
;	OUT:	V_TOTAL_H/LiώZlj
;--------------------------------------------------------------------------------

GET_DATA:

;	MOVLW	B'10001001'		; AN2, A/D CONV Power ON
;	MOVWF	ADCON0			; Bank 0
;	CALL	WAIT_10us		; v`[W҂

	CALL	READ_VOLTAGE10	; AN2 drd擾

	MOVF	AD_H,W			; lݐ
	MOVWF	B1
	MOVF	AD_L,W
	MOVWF	B2

	MOVF	V_TOTAL_H,W
	MOVWF	A1
	MOVF	V_TOTAL_L,W
	MOVWF	A2

	CALL	ADD16			; lZA A1,A2

	MOVF	A1,W
	MOVWF	V_TOTAL_H
	MOVF	A2,W
	MOVWF	V_TOTAL_L

	RETURN

;--------------------------------------------------------------------------------
;	drdAlAl擾
;	OUT:	MAX_H/L, MIN_H/LiA/Dϊlj
;--------------------------------------------------------------------------------

GET_DATA2:

; l擾

	BCF		INTCON,T0IE		; A/D ϊ TMR0 荞݋֎~iAN2 ̃v`[WԊmۂ̂߁j

	MOVLW	B'10000001'		; AN0, A/D CONV Power ON
	MOVWF	ADCON0			; Bank 0

	CALL	WAIT_10us		; v`[W҂

	CALL	READ_VOLTAGE10	; AN0 f[^擾

	MOVF	AD_H,W			; lۑ
	MOVWF	MAX_H
	MOVF	AD_L,W
	MOVWF	MAX_L

; l擾

	MOVLW	B'10000101'		; AN1, A/D CONV Power ON
	MOVWF	ADCON0			; Bank 0

	CALL	WAIT_10us		; v`[W҂

	CALL	READ_VOLTAGE10	; AN1 f[^擾

	MOVLW	B'10001001'		; AN2 ɖ߂Ă
	MOVWF	ADCON0

	MOVF	AD_H,W			; lۑ
	MOVWF	MIN_H
	MOVF	AD_L,W
	MOVWF	MIN_L

	CALL	WAIT_5us		; Ô AN2 v`[W

	BSF		INTCON,T0IE		; TMR0 荞ݍċ

	RETURN

;--------------------------------------------------------------------------------
;	d̕ϒlZo
;	IN:		VTH/L
;	OUT:	VLT_H/L
;--------------------------------------------------------------------------------

CALC_AVERAGE:

	MOVF	VTH,W
	MOVWF	A1				; q
	MOVF	VTL,W
	MOVWF	A2				; q

	CLRF	B1				; 
	MOVLW	AVG
	MOVWF	B2				; q

	CALL	DIV16			; ϒlZoA A1, A2

	MOVF	A1,W
	MOVWF	VLT_H			; ϓdlXV
	MOVF	A2,W
	MOVWF	VLT_L

	RETURN

;--------------------------------------------------------------------------------
;	e A/D l𒼓ǒl x10ɕϊ
;	IN:		VLT_H/L, MAX_H/L, MIN_H/L
;	RETURN:	VOLTAGE, MIN, MAX
;--------------------------------------------------------------------------------

CONV_DATA:

							; drd
	MOVF	VLT_H,W			; dA/Dϊl
	MOVWF	A1
	MOVF	VLT_L,W
	MOVWF	A2

	CLRF	B1
	MOVLW	FACTOR			; WŊĒǒl𓾂
	MOVWF	B2

	CALL	DIV16			; in math16.lib, returns A1A2

	MOVF	A2,W			; d(͉8bit݂̂Ŋm)ۑĂ
	MOVWF	VOLTAGE
							; lƉl͒ǒlŔri8bitrłނj
							; l
	MOVF	MAX_H,W
	MOVWF	A1
	MOVF	MAX_L,W
	MOVWF	A2

	CLRF	B1
	MOVLW	FACTOR			; WŊĒǒl𓾂
	MOVWF	B2

	CALL	DIV16			; in math16.lib, returns A1A2
	MOVF	A2,W			; (͉8bit݂̂Ŋm)ۑĂ
	MOVWF	MAX

							; l
	MOVF	MIN_H,W
	MOVWF	A1
	MOVF	MIN_L,W
	MOVWF	A2

	CLRF	B1
	MOVLW	FACTOR			; WŊĒǒl𓾂
	MOVWF	B2

	CALL	DIV16			; in math16.lib, returns A1A2

	MOVF	A2,W			; (͉8bit݂̂Ŋm)ۑĂ
	MOVWF	MIN

	MOVF	MAX,W
	SUBWF	MIN,W			; MIN - MAX(W) -> W
	BTFSS	STATUS,C		;  MIN >= MAX Ȃ؂ꂪ C=1 Ŏ̍sXLbv
	RETURN					; MAX > MIN Ȃ̂ł̂܂ܖ߂

	MOVF	MAX,W			; MAX  MIN ւ
	MOVWF	TMP
	MOVF	MIN,W
	MOVWF	MAX
	MOVF	TMP,W
	MOVWF	MIN

	RETURN

;--------------------------------------------------------------------------------
;	 & A/Dϊݐϒl̏
;--------------------------------------------------------------------------------

CLEAR_PARAM:

	CLRF	V_TOTAL_H			; dݐϒlNA
	CLRF	V_TOTAL_L

	MOVLW	AVG					; 32ms x AVG ŕϒlvZ
	MOVWF	INT_COUNTER			; ԃJE^[

	RETURN

;--------------------------------------------------------------------------------
;	Cuǂݍ
;--------------------------------------------------------------------------------

	INCLUDE		Time-8MHz.lib	; NbN8MHzpԑ҂[vCu
	INCLUDE		Math16.lib		; 16bit lZCu

;--------------------------------------------------------------------------------
;	vOI
;--------------------------------------------------------------------------------

	END
